# -*- coding: utf-8 -*-

from ..utils import *


class bloco_p(TrackedAttributesClass):
    """
        BLOCO P: APURAÇÃO DA CONTRIBUIÇÃO PREVIDENCIÁRIA SOBRE A
        RECEITA BRUTA
    """

    class registro_P001(TrackedAttributesClass):
        """
            REGISTRO P001: ABERTURA DO BLOCO P
        """
        _order = []

        def __init__(self):
            super(bloco_p.registro_P001, self).__init__()
            self.REG = 'P001'  # Texto fixo contendo.
            self.nivel_h = 1  # nível
            self.pai = '0000'
            self.ocorrencia = '1'  # ocorrência por arquivo
            self.IND_MOV = ''  # Indicador de movimento:0- Bloco com dados informados;1- Bloco sem dados informados.
            self.fieldnames = ('REG', 'IND_MOV')
            self.formato = self.get_formato()

    class registro_P990(TrackedAttributesClass):
        """
        REGISTRO P990: ENCERRAMENTO DO BLOCO G
        Este registro deve ser gerado para o encerramento do Bloco P e indica o número total de registros existentes neste Bloco
        """
        _order = []

        def __init__(self):
            super(bloco_p.registro_P990, self).__init__()
            self.REG = 'P990'  # Texto fixo contendo.
            self.nivel_h = 1  # nível
            self.pai = '0000'
            self.ocorrencia = '1'  # ocorrência por arquivo
            self.QTD_LIN_P = ''
            self.fieldnames = ('REG', 'QTD_LIN_P')
            self.formato = self.get_formato()
